/******************************************************************************
 *    MonologObject.h
 *
 *    This file is part of PyNumbra
 *    Copyright (C) 2004 Tom N Harris <telliamed@whoopdedo.cjb.net>
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *****************************************************************************/

#ifdef MONOOBJECT
#ifndef MONOLOGOBJECT_H
#define MONOLOGOBJECT_H
#include <Python.h>
//#include <lg/types.h>

//interface IDebugScrSrv;

namespace PyNumbra
{
	class MonologObject : public PyObject
	{
		int m_bSoftspace;
		//IDebugScrSrv *m_pDSS;
		unsigned int m_iPos;
		char m_chReadBuf[1024];

		//static const cScrStr _Nil;

	public:
		static PyObject * New(void);
		static int Init(MonologObject *self, PyObject *args, PyObject *kwds);
		static void Dealloc(MonologObject *self);

		//static PyObject* GetAttr(MonologObject *self, PyObject *attr);
		//static int SetAttr(MonologObject *self, PyObject *attr, PyObject *arg);
		static PyObject* GetName(MonologObject *self, void*);
		static PyObject* GetClosed(MonologObject *self, void*);
		static PyObject* GetSoftspace(MonologObject *self, void*);
		static int SetReadOnly(MonologObject *self, PyObject *attr, void*);
		static int SetSoftspace(MonologObject *self, PyObject *attr, void*);
		
		static PyObject * Str(MonologObject *self);

		static PyObject * Close(MonologObject *self);
		static PyObject * Flush(MonologObject *self);
		static PyObject * Write(MonologObject *self, PyObject *args);
		
		static const char *Name;
		static const PyMethodDef Methods[];
		static const PyGetSetDef Members[];
		static PyTypeObject Type;
	};

	inline PyObject * OpenMonolog(void)
		{ return MonologObject::New(); }
}

#endif
#endif
