/******************************************************************************
 *    PyNumbraModule.h
 *
 *    This file is part of PyNumbra
 *    Copyright (C) 2004 Tom N Harris <telliamed@whoopdedo.cjb.net>
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *****************************************************************************/

#include <Python.h>
#include <lg/objects.h>
#include <lg/links.h>
#include "interface.h"

namespace PyNumbra
{

	extern CInterface<ILinkManager> CLinkManager;
	extern CInterface<IObjectSystem> CObjectSystem;
	extern CInterface<ITraitManager> CTraitManager;
	
	struct RelationCache
	{
		static PyObject * m_Relations;
		static PyObject * m_RelationMap;

		static void Init(void);
		static int Named(PyObject *obName);
		static PyObject * Name(int id);
	};

	PyObject * LinkKindNamed(PyObject *self, PyObject *args);
	PyObject * LinkKindName(PyObject *self, PyObject *args);

	extern "C" __declspec(dllexport)
	PyObject * initPyNumbra(void);

} // namespace PyNumbra

