'''ScriptLib.py
    
    Common script operations.

    This file is part of PyNumbra
    Copyright (C) 2004 Tom N Harris <telliamed@whoopdedo.cjb.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'''

__all__ = ['GetObjectParam']

from PyNumbra import *
import re

__ParamPattern = re.compile('''\s*(\w+)=("[^"]*"|'[^']*'|[^'";]*)(?:;|\Z)''')

def GetObjectParam(obj,param):
    propsrv = ScriptServices.PropertyService()
    if propsrv.Possessed(obj,'DesignNote'):
        data = propsrv.Get(obj,'DesignNote')
        for pr in __ParamPattern.findall(data):
            if pr[0].lower() == param.lower():
                r = pr[1]
                if r[0] in ("'",'"'):
                    r = r[1:-1]
                return r
    return None

if __name__ == '__main__':
    pass
