#ifdef __cplusplus
extern "C" {
#endif

typedef int (__cdecl *GetNextMission)(void);
typedef int (__cdecl *SetNextMission)(int);
struct sLoopInstantiator;
typedef sLoopInstantiator* (__cdecl *DescribeMissionLoopMode)(void);

typedef const char* (__cdecl *AppName)(void);
typedef void (__cdecl *AppSelectGame)(int);

typedef int (__cdecl *MoviePlaySynchronous)(const char* filename, int volume);

enum eCmdType {
	kCmdTypeFunc = 0,
	kCmdTypeBoolFunc,
	kCmdTypeIntFunc,
	kCmdTypeFloatFunc,
	kCmdTypeDoubleFunc,
	kCmdTypeStringFunc,
	kCmdTypeBoolVar,
	kCmdTypeIntVar,
	kCmdTypeStringVar,
	kCmdTypeIntArray,
	kCmdTypeFloatVar,
	kCmdTypeBoolToggle,
	kCmdTypeIntToggle,
};
enum eCmdContext {
	kCmdCtxDefault = 0,  /* Inherits the context passed to CommandRegister */
	kCmdCtxGameMode = 1,
	kCmdCtxEditorMode = 2,
	kCmdCtxEditor = 4, /* Most commands with kCmdCtxEditorMode also have this set. */
	kCmdCtxAlways = -1
};
typedef int (__cdecl *cmd_func)(void);
typedef int (__cdecl *cmd_bool_func)(int);
typedef int (__cdecl *cmd_int_func)(int);
typedef int (__cdecl *cmd_float_func)(float);
typedef int (__cdecl *cmd_double_func)(double);
typedef int (__cdecl *cmd_string_func)(const char*);
typedef struct CommandInfo_
{
	const char* cmd;
	int cmd_type;
	union {
		cmd_func _f;
		void* _p;
	} cmd_ptr;
	const char* cmd_help;
	int cmd_context;
} CommandInfo;
/* The CommandInfo struct is *not* const. */
typedef void (__cdecl *CommandRegister)(CommandInfo* cmd_info, int num_cmds, int cmd_context);

typedef int (__cdecl *config_get_value)(const char* name, int type, void* return_buffer, int* item_count);
typedef int (__cdecl *config_get_single_value)(const char* name, int type, void* return_buffer);
/* pass NULL,0 for the buffer and it will simply return if the variable exists or not */
typedef const char* (__cdecl *config_get_raw)(const char* name, char* buffer, int buffer_size);
typedef int (__cdecl *config_iter_func)(const char*);
typedef int (__cdecl *config_get_raw_all)(config_iter_func, char* buffer, int buffer_size);

typedef int (__cdecl *prompt_bool)(char* default_value);
typedef int (__cdecl *prompt_int)(char* default_value);
typedef double (__cdecl *prompt_double)(char* default_value);
typedef char* (__cdecl *prompt_string)(char* default_value, char* return_buffer);

typedef int (__cdecl *lg_sprintf)(char*, const char*, ...);
typedef int (__cdecl *_mprint)(const char*, int);
/* just calls _mprint(arg, strlen(arg)); */
typedef int (__cdecl *mprint)(const char*);
/* This uses a 1024 byte static buffer, watch for overflow. */
typedef int (__cdecl *mprintf)(const char*, ...);

/* Prints to the status line, and also (optionally) to the mono. */
typedef void (__cdecl *Status)(const char*);
/* You probably want to use field 4 (max is 8). String is limited to 128, and it actually uses strncpy too! */
typedef void (__cdecl *StatusField)(int,const char*);

typedef void (__cdecl *FlashOnlyPlayer)(int obj_id);

#ifdef __cplusplus
}
#endif
